from py4j.java_gateway import get_field

class Machete(object):
	def __init__(self, gateway):
		self.gateway = gateway

		self.close()

	def getCharacter(self):
		return "ZEN"

	def close(self):
		self.inputKey = None
		self.player = None
		self.frameData = None
		self.cc = None
		self.simulator = None
		self.gameData = None

	def getInformation(self, frameData):
		self.frameData = frameData

	def initialize(self, gameData, player):
		self.inputKey = self.gateway.jvm.structs.Key()
		self.player = player
		self.frameData = self.gateway.jvm.structs.FrameData()
		self.cc = self.gateway.jvm.commandcenter.CommandCenter()
		self.gameData = gameData
		self.simulator = self.gameData.getSimulator()
		self.isGameJustStarted = True

		return 0

	def input(self):
		return self.inputKey

	def processing(self):
		if self.frameData.getEmptyFlag() or self.frameData.getRemainingTime() <= 0:
			self.isGameJustStarted = True
			return

		if not self.isGameJustStarted:
			self.frameData = self.simulator.simulate(self.frameData, self.player, None, None, 17)
		else:
			self.isGameJustStarted = False

		self.cc.setFrameData(self.frameData, self.player)

		distance = self.cc.getDistanceX()

		my = self.cc.getMyCharacter()
		energy = my.getEnergy()
		my_x = get_field(my, 'x')
		my_state = get_field(my, "state")

		opp = self.cc.getEnemyCharacter()
		opp_x = get_field(opp, 'x')
		opp_state = get_field(opp, "state")

		xDifference = my_x - opp_x

		if self.cc.getskillFlag():
			self.inputKey = self.cc.getSkillKey()
			return

		self.inputKey.empty()
		self.cc.skillCancel()

		if (get_field(opp, "energy") >= 300) and ((get_field(my, "hp") - get_field(opp, "hp")) <= 300):
			self.cc.commandCall("FOR_JUMP _B B B")
		elif not my_state.equals(self.gateway.jvm.enumerate.State.AIR) and not my_state.equals(self.gateway.jvm.enumerate.State.DOWN):
			if distance > 150:
				self.cc.commandCall("FOR_JUMP")
			elif energy >= 300:
				self.cc.commandCall("STAND_D_DF_FC")
			elif (distance > 100) and (energy >= 50):
				self.cc.commandCall("STAND_D_DB_BB")
			elif opp_state.equals(self.gateway.jvm.enumerate.State.AIR):
				self.cc.commandCall("STAND_F_D_DFA")
			elif distance > 100:
				self.cc.commandCall("6 6 6")
			else:
				self.cc.commandCall("B")
		elif ((distance <= 150) and (my_state.equals(self.gateway.jvm.enumerate.State.AIR) or my_state.equals(self.gateway.jvm.enumerate.State.DOWN))
			and (((self.gameData.getStageXMax() - my_x) >= 200) or (xDifference > 0)) 
			and ((my_x >= 200) or xDifference < 0)):
			if energy >= 5:
				self.cc.commandCall("AIR_DB")
			else:
				self.cc.commandCall("B")
		else:
			self.cc.commandCall("B")

	class Java:
		implements = ["gameInterface.AIInterface"]